% By Yuxiang Yan, November 2, 2017
clear;
Path = '.';
sublist = textread(['../1_model_training/list_train_and_test.txt'], '%s');
ROI_names = textread(['../1_model_training/ROI_lh_fs4_list.txt'],'%s');

% --- Change start ---
% Dataset = 'GSP_lh_Test20'; %'GSP_lh_Test20_S5'; 'GSP_lh_Test20';
Subject_nos = 89; %89; %81:100;
combo_sim_real = cell(1,5);
combo_sim_train = cell(1,5);
combo_sim_real2 = cell(1,5);
combo_sim_train2 = cell(1,5);

Hemispheres = {'lh'};
%Eliminated_regions = {'temporal2_lh'},'lat_frontal_lh','med_frontal_lh','parietal_lh','occipital_lh'};
Eliminated_regions = {'temporal2_lh'};

% --- Change end ---
annotation_file = load(['../1_model_training/Eliminating_regions/annotation_file.mat']);
annotation_file = annotation_file.annotation_file;
vertex_location = load(['../1_model_training/VertexLocation/vertex_location.mat']);
vertex_location = vertex_location.vertex_location;
annotation_file(vertex_location(:,1)==-50,2) = -1;

all_mask = zeros(2562,1);
for m = 1:length(Eliminated_regions)
    mask_file{m} = load_mgh(['eliminated_mask_' Eliminated_regions{m} '.mgh' ]);
    mask_file{m}(mask_file{m}~=0) = 1;
    all_mask = all_mask + mask_file{m};
    mask_file{m} = 1 - mask_file{m};
end
all_mask(all_mask~=0) = 1;
for m = 1:length(Eliminated_regions)
    mask_file{m} = mask_file{m}.*all_mask;
end

% mask_file{1} = double(annotation_file(:,2)==10) + double(annotation_file(:,2)==16);
load('fs4_Firstadjacent_vertex.mat');

for Subject_no = Subject_nos
    s = Subject_no
    subject = sublist{s*2-1};
    Dataset = ['GSP_lh_Test20_'  num2str(Subject_no)];
    
    for h = 1:length(Hemispheres)
        hemisphere = Hemispheres{h};

        RealBOLD = load_mgh(['demo/GSP_lh_Test20_' num2str(s) '_' subject '_ReconstructedBOLD.mgh']);

        Type = 'SimulatedBOLD';
        for eli = 1:length(Eliminated_regions)
            eliminated_region = Eliminated_regions{eli};
            OutPath = ['/ReconstructedBOLD/VertexROIs/' eliminated_region '/mghfile'];
%             mkdir(OutPath);
            
            SimBOLD = load_mgh(['demo/' Dataset '_' num2str(s) '_' subject '_' Type '_' eliminated_region '.mgh']);
            
            SimBOLD2 = SimBOLD.*repmat(mask_file{eli},1,size(SimBOLD,2));
            for n=1:size(SimBOLD2,1)
                SimBOLD3(n,:) =  mean(SimBOLD2(fs4_Firstadjacent_vertex_lh{n},:));
            end
            
            % Similairty to original corresponding signal
            [sim_real_corr,p] = corr(permute(RealBOLD(mask_file{eli}~=0,:),[2,1]),permute(SimBOLD3(mask_file{eli}~=0,:),[2,1]));
            sim_real_corr2 = diag(sim_real_corr);
            sim_real_corr2(isnan(sim_real_corr2)) = 0;
            all_sim_real_corr(Subject_nos==Subject_no,eli) = sum(sim_real_corr2)./length(find(sim_real_corr2~=0));
            all_sim_real_corr_std(Subject_nos==Subject_no,eli) = std(sim_real_corr2(sim_real_corr2~=0));
            all_sim_real_corr2(:,eli) = [sum(sim_real_corr2(sim_real_corr2>0))./length(find(sim_real_corr2>0)); length(sim_real_corr2); length(find(sim_real_corr2>0))./length(find(sim_real_corr2~=0))];
            
            p2 = diag(p); p2(isnan(sim_real_corr2)) = [];
            
            % ROI activations
            SimBOLD4 = SimBOLD3 + RealBOLD.*repmat(1-mask_file{eli},1,size(RealBOLD,2));
            
            loc_label = find(mask_file{eli}~=0);
            [I,Y] = sort(sim_real_corr2,'descend');
            clear corr_list; clear corr_list2;
            for seed_num = 1:length(loc_label)
                seed_location = loc_label(Y(seed_num));
                FC_real = corr(permute(RealBOLD(seed_location,:),[2 1]),permute(RealBOLD,[2 1]));
                FC_real(isnan(FC_real)) = 0;
                FC_realz = atanh(FC_real);
                FC_sim = corr(permute(SimBOLD4(seed_location,:),[2 1]),permute(SimBOLD4,[2 1]));
                FC_sim(isnan(FC_sim)) = 0;
                FC_simz = atanh(FC_sim);
                
                corr_list(seed_num) = corr(FC_real',FC_sim');
                corr_list2(seed_num) = corr(permute(FC_real(mask_file{eli}~=0),[2 1]),permute(FC_sim(mask_file{eli}~=0),[2 1]));
                if seed_num<=0 %|| corr_list2(seed_num)>=corr_list2(1)
                    save_mgh(FC_realz,[OutPath '/' num2str(seed_num) '_Vertex_' num2str(seed_location) '_real.mgh'],eye(4));
                    save_mgh(FC_simz,[OutPath '/' num2str(seed_num) '_Vertex_' num2str(seed_location) '_' num2str(I(seed_num)) '_' num2str(corr_list(seed_num)) '_sim.mgh'],eye(4));
                end
            end
            
            corr_list(isnan(corr_list)) = 0;
            corr_list2(isnan(corr_list2)) = 0;
            [I3,Y3] = sort(corr_list.*3 + corr_list2,'descend');
            
            % save vertex with max inside-mask similarity
            for seed_num = 1:50
                seed_location = loc_label(Y(Y3(seed_num)));
                FC_real = corr(permute(RealBOLD(seed_location,:),[2 1]),permute(RealBOLD,[2 1]));
                FC_sim = corr(permute(SimBOLD4(seed_location,:),[2 1]),permute(SimBOLD4,[2 1]));
                
                FC_real(isnan(FC_real.*FC_sim)) = 0;
                FC_realz = atanh(FC_real);
                FC_sim(isnan(FC_real.*FC_sim)) = 0;
                FC_simz = atanh(FC_sim);
                
                save_mgh(FC_realz,[OutPath '/' num2str(seed_num) '_Vertex_' num2str(seed_location) '_real.mgh'],eye(4));
                save_mgh(FC_simz,[OutPath '/' num2str(seed_num) '_Vertex_' num2str(seed_location) '_' num2str(I(seed_num)) '_' num2str(corr_list(seed_num)) '_sim.mgh'],eye(4));
                corr(permute(FC_real(mask_file{eli}~=0),[2 1]),permute(FC_sim(mask_file{eli}~=0),[2 1]));
            end
            
            SimBOLD5 = corr(permute(SimBOLD3(loc_label(Y),:),[2 1]));
            
            % Snapshot using csh code.
            
            % Plot BOLD fluctaution
            if eli == 1
                selected_vertices = [1 4 22];
%                 figure; hold on; v2 = 1;
%                 for v = selected_vertices
%                     seed_location = loc_label(Y(v))
%                     plot(RealBOLD(seed_location,:)./max(abs(RealBOLD(seed_location,:)))+1.5*v2,'r');
%                     plot(SimBOLD3(seed_location,:)./max(abs(SimBOLD3(seed_location,:)))+1.5*v2,'b');
% 
%                     v2 = v2 + 1;
%                 end
%                 corrcoef(SimBOLD3(loc_label(Y(1)),42:107),SimBOLD3(loc_label(Y(22)),42:107))
%                 corrcoef(RealBOLD(loc_label(Y(1)),42:107),SimBOLD3(loc_label(Y(1)),42:107))
%                 corrcoef(RealBOLD(loc_label(Y(22)),42:107),SimBOLD3(loc_label(Y(22)),42:107))
% 
%                 [r, p] = corrcoef(SimBOLD3(loc_label(Y(1)),:),SimBOLD3(loc_label(Y(22)),:))
%                 [r, p] = corrcoef(RealBOLD(loc_label(Y(1)),:),SimBOLD3(loc_label(Y(1)),:))
%                 [r, p] = corrcoef(RealBOLD(loc_label(Y(22)),:),SimBOLD3(loc_label(Y(22)),:)) 
            end
            
            % Statistical analysis
            all_sim_train_corr = [];
            for n = 1:80
%                 n
                subject_train = sublist{n*2-1};
                test_BOLD = load_mgh([Path '/ReconstructedBOLD/GSP_lh_Train80/GSP_lh_Train80_' num2str(n) '_' subject_train '_ReconstructedBOLD.mgh']);
                
                sim_train_corr = corr(permute(test_BOLD(mask_file{eli}~=0,:),[2,1]),permute(SimBOLD3(mask_file{eli}~=0,:),[2,1]));
                sim_train_corr2 = diag(sim_train_corr);
                sim_train_corr2(isnan(sim_train_corr2)) = [];
                all_sim_train_corr = [all_sim_train_corr;sim_train_corr2];
            end
            
            mean_sim_real = mean(sim_real_corr2(sim_real_corr2~=0)); std_sim_real = std(sim_real_corr2(sim_real_corr2~=0));
            mean_sim_train = mean(all_sim_train_corr(all_sim_train_corr~=0)); std_sim_train = std(all_sim_train_corr(all_sim_train_corr~=0));
            nums_each_region(eli) = length(sim_real_corr2(sim_real_corr2~=0));
            combo_sim_real{eli} = [combo_sim_real{eli} sim_real_corr2(sim_real_corr2~=0)];
            combo_sim_train{eli} = [combo_sim_train{eli} all_sim_train_corr(all_sim_train_corr~=0)];
            combo_sim_real2{eli} = [combo_sim_real2{eli} corr_list(corr_list~=0)];
%             combo_sim_train2{eli} = [combo_sim_train2{eli} all_sim_train_corr(all_sim_train_corr~=0)];            
            
%             figure;hold on;
%             bar([mean_sim_real mean_sim_train],0.2,'k');
%             plot([1 1],[mean_sim_real-std_sim_real mean_sim_real+std_sim_real],'k','LineWidth',2);
%             plot([2 2],[mean_sim_train-std_sim_train mean_sim_train+std_sim_train],'k','LineWidth',2);
%             hold off;
%             xlim([0 3]);
            temp2{eli} = [mean_sim_real std_sim_real];
            temp3{eli} = [mean(corr_list(corr_list~=0)) std(corr_list(corr_list~=0))];
             
            simi_trend = [I';corr_list];
            simi_trend(3,:) = I'./max(I) + corr_list./max(corr_list);
            [I2,Y2] = sort(simi_trend(3,:),'descend');
%             figure; H = bar(permute(simi_trend(1:2,Y2),[2,1]));
%             legend('BOLD fluctuation','FCmap');
        end
    end

end

