% This function is used to extract the value from flattened map and transform back
% to true bold activated value.
% By Yuxiang, August 24, 2017

% Version for Simulated Images

clear;clc;

% ---- Change Start ----

Path = '.';
sublist = textread([Path '/Lists/list_train_and_test.txt'], '%s');
Subject_nos = [89];
% Dataset = 'GSP_lh_Test20_94_clear'; % 'GSP_lh_Test20_ET'; ET means the loss function is temporal lobe eliminated

for Subject_no = Subject_nos
    Dataset = ['GSP_lh_Test20_' num2str(Subject_no)];
    disp(['============ SUBJECT_NUMBER IS ' num2str(Subject_no) ' ==============']);


ImageSet = ['../1_model_training/demo/results/'];

% Eliminated_regions = {'temporal_lh','lat_frontal_lh','med_frontal_lh','parietal_lh','occipital_lh'};
Eliminated_regions = {'temporal2_lh'};

Hemispheres = {'lh'};
Bolds = {'013','014'};
Frames = 1:120;

vertex_location = load(['../1_model_training/VertexLocation/vertex_location.mat']);
label_list = textread(['/demo/simulated_labels_' Dataset '.txt'], '%s');

% vertex_number = 2562;

% ---- Change Stop ----

mkdir([Path '/ReconstructedBOLD/' Dataset]);

for s = Subject_no
    if s<=80
        set_name = 'Train80';
    else
        set_name = 'Test20';
    end
    
    subject = sublist{s*2-1}
    
    for eli = 1:length(Eliminated_regions)
        elinimated_region = Eliminated_regions{eli}
        
        mkdir([Path '/ReconstructedBOLD/SingleFrames_Simulated/' elinimated_region]);
        for h = 1:length(Hemispheres)
            hemishpere = Hemispheres{h};

            Simulated_BOLD = zeros(2562,length(Bolds).*length(Frames));

            for b = 1:length(Bolds)
                bold = Bolds{b};
                for f = Frames
                    frame = Frames(f);

                    % Get the index of each frame
                    label_name = [set_name '_' num2str(s) '_' subject '_' hemishpere '_' bold '_' num2str(frame)]
    %                 label_name = 'lh_AD_16_16_1445'
                    idx = [];
                    for g = 1:length(label_list)
                        if strcmp(label_name, label_list{g})==1
                            idx = g;
                        end
                    end

                    image_name = ['image_idx' num2str(idx-1) '_z0_iter500.png']; %image_idx92_z0_iter500.png

                    % Load flattened image
                    flattened_image = double(imread([ImageSet '/' elinimated_region '/' image_name]));
                    if size(flattened_image,1) == 600
                        flattened_image = flattened_image(51:550,51:550,:);
                    end

                    transformed_bold = zeros(size(vertex_location.vertex_location,1),4); % store rgb and transformed value
                    for nn = 1:size(vertex_location.vertex_location,1)
                        the_location = vertex_location.vertex_location(nn,1:2);
                        if the_location(1) == -50
                            transformed_bold(nn,1:3) = [-2 -2 -2]; % [0 0 0]
                        else
                            transformed_bold(nn,1:3) = flattened_image(the_location(1),the_location(2),:);
                        end
                    end

                    % Change the green value to negative if r < b
                    temp_g = transformed_bold(transformed_bold(:,1)>0,2);
                    min_g = min(temp_g);
                    transformed_bold(:,2) = transformed_bold(:,2) - min_g;
                    transformed_bold((transformed_bold(:,1)<transformed_bold(:,3)),2) = - transformed_bold((transformed_bold(:,1)<transformed_bold(:,3)),2);

    %                 transformed_bold(transformed_bold(:,2)>=0,4) = transformed_bold(transformed_bold(:,2)>=0,2).*min(0.5,max(bold_activation))./(max(transformed_bold(:,2)));
                    transformed_bold(transformed_bold(:,2)>=0,4) = transformed_bold(transformed_bold(:,2)>=0,2).*0.5/(max(transformed_bold(:,2)));
    %                 transformed_bold(transformed_bold(:,2)<0,4) = transformed_bold(transformed_bold(:,2)<0,2).*0.5,(0 - min(bold_activation)))./(0 - min(transformed_bold(:,2)));
                    transformed_bold(transformed_bold(:,2)<0,4) = transformed_bold(transformed_bold(:,2)<0,2).*0.5/(0 - min(transformed_bold(:,2)));

                    transformed_bold(transformed_bold(:,1)==-2,4) = -2;

                    Simulated_BOLD(:,(b-1)*120+f) = transformed_bold(:,4);

                    save_mgh(Simulated_BOLD, [Path '/demo/SingleFrames_Simulated/' elinimated_region '/' set_name '_' num2str(s) '_' subject '_' hemishpere '_' bold '_' num2str(frame) '.mgh'], eye(4));
                end
            end
            save_mgh(Simulated_BOLD, [Path '/demo/' Dataset '_' num2str(s) '_' subject '_SimulatedBOLD_' elinimated_region '.mgh'], eye(4));
        end
    end
end
end